/*
 *
 *  MIME 饤֥
 *
 *  Copyright 1993-1996 Matsushita Soft Research, INC. A.Takuma
 *
 *  System      : MIME Manage Library
 *  Sub system  : MIME encode/decode define
 *  File        : mimelib.h
 *  Version     : 0.30
 *  First Edit  : 1993-08/09
 *  Last  Edit  : 1996-11/18
 *  Author      : MSR24  
 *
 */

#ifndef __MIMELIB_H
#define __MIMELIB_H

#ifdef	WINDOWS
#include	<windows.h>
#endif	/* WINDOWS */

#define	MIME_ENCODE_START	"=?"
#define	MIME_ENCODE_END		"?="
#define	MIME_SEP_CHAR		'?'
#define	MIME_PAD_CHAR		'='
#define	MIME_SPC_CHAR		'_'

#define	MIME_ENCODE_BASE64	'B'	/* Base 64 Encoding */
#ifdef	notdef
#define	MIME_ENCODE_QP		'Q'	/* Quoted Printable Encoding */
#else	/* !notdef */
#define	MIME_ENCODE_Q		'Q'	/* Quoted */
#endif	/* !notdef */

#define	MIME_CHARSET_ASCII	"US-ASCII"
#define	MIME_CHARSET_ISO8859	"ISO-8859-"
#define	MIME_CHARSET_ISO2022_1	"ISO-2022-JP"
#define	MIME_CHARSET_ISO2022_2	"ISO-2022-JP-2"
#define	MIME_CHARSET_UNKNOWN	"UNKNOWN"

#define	CONTENT_FIELD		"Content-Type:"
#define	TRANSFER_FIELD		"Content-Transfer-Encoding:"
#define	MIME_VER_FIELD		"Mime-Version:"

#define	MIME_VERSION		"1.0"

#define	MIME_TRANS_7BIT		"7bit"
#define	MIME_TRANS_8BIT		"8bit"
#define	MIME_TRANS_QP		"quoted-printable"
#define	MIME_TRANS_BASE64	"base64"
#define	MIME_TRANS_BINARY	"binary"
#define	MIME_CHARSET		"charset"

#define	MIME_TYPE_TEXT		"text"
#define	MIME_TYPE_APPLICATION	"application"
#define	MIME_TYPE_AUDIO		"audio"
#define	MIME_TYPE_IMAGE		"image"
#define	MIME_TYPE_MESSAGE	"message"
#define	MIME_TYPE_VIDEO		"video"
#define	MIME_TYPE_EXTENSION	"extension-token"
#define	MIME_TYPE_MULTI		"multipart"

#define	MIME_SUBTYPE_PLAIN	"plain"
#define	MIME_SUBTYPE_RICH	"richtext"
#define	MIME_SUBTYPE_MIX	"mixed"
#define	MIME_SUBTYPE_PARA	"parallel"
#define	MIME_SUBTYPE_DIGEST	"digest"
#define	MIME_SUBTYPE_ALT	"alternative"
#define	MIME_SUBTYPE_RFC	"rfc822"
#define	MIME_SUBTYPE_PART	"partial"
#define	MIME_SUBTYPE_EXT	"external-body"
#define	MIME_SUBTYPE_GIF	"gif"
#define	MIME_SUBTYPE_JPEG	"jpeg"
#define	MIME_SUBTYPE_BASIC	"basic"
#define	MIME_SUBTYPE_MPEG	"mpeg"
#define	MIME_SUBTYPE_OCT	"octet-stream"
#define	MIME_SUBTYPE_PS		"postscript"

#define	MAX_ENCODE_COLUMN	75
#define	MIME_SEP_SIZE1		16	/* "=?ISO-2022-JP?B?" */
#define	MIME_SEP_SIZE2		2	/* "?=" */

/*
 * define  B64 󥳡ʸܤ򥨥󥳡/ǥ
 * 롼ŬѤ
 */

/*
#define	ENCODE_SPACE
*/

#ifdef	WINDOWS
/* "Ignoring unrecognized code in MIME-Q." */
#define MIME_ERROR_CODE_1	1
/* "Ignoring unrecognized boundary line in MIME-B64." */
#define MIME_ERROR_CODE_2	2
/* "Unexpected EOL in MIME-B64." */
#define MIME_ERROR_CODE_3	3

#ifdef	BUILD_MIMELIB_DLL
	#define MIMELIBFUNC __stdcall __export
#else	/* !BUILD_MIMELIB_DLL */
	#define MIMELIBFUNC __stdcall __import
#endif	/* !BUILD_MIMELIB_DLL */

int MIMELIBFUNC mime_encode(char *src, char *dst);
int MIMELIBFUNC mime_decode(char *src, char *dst);
DWORD MIMELIBFUNC mime_GetLastError();
#else	/* !WINDOWS */
int	mime_encode_jis();	/* MIME 󥳡(JIS ) */
int	mime_decode_euc();	/* MIME ǥ(EUC ) */
int	mime_encode();		/* MIME 󥳡 */
int	mime_decode();		/* MIME ǥ */
#endif	/* !WINDOWS */
#endif	/* __MIMELIB_H */
