/*
 *
 *  POP3 饤֥
 *
 *  Copyright 1995-1996 Matsushita Soft Research, INC. A.Takuma
 *
 *  System      : POP3 protocol library
 *  Sub system  : POP3 library
 *  File        : pop3lib.c
 *  Version     : 0.40
 *  First Edit  : 1995-12/25
 *  Last  Edit  : 1996-11/10
 *  Author      : MSR24  
 *
 */

#include	"compat.h"
#include	"pop3lib.h"
#include	"field.h"

char			pop3_server[MAXHOSTNAMELEN];
					/* POP3 Хۥ̾(FQDN)	*/
char			pop3_server_file[PATH_BUFF] = POP3_SERVER_FILE;
					/* POP3 лե	*/
char			mail_spool[PATH_BUFF] = MAIL_SPOOL;
					/* ᡼륹ס		*/
short			pop3_connect_mode = 2;
					/* POP3 ³⡼		*/
					/* (0:MSPL,1:POP3,2:DEAD)	*/
short			pop3_rpop_mode = 0;
					/* POP3 RPOP ѥ⡼		*/
char			*pop3_connect_string[] = {
  "MSPL",
  "POP3",
  "DEAD",
};

#ifdef	MSPL
static FILE		*spool_fp = (FILE*)NULL;
#endif	/* MSPL */
#ifdef	POP3
static int		spool_num = 0;
static int		read_num = -1;
#ifdef	MSDOS
static int		read_fd = -1;
static int		write_fd = -1;
#else	/* !MSDOS */
static FILE		*read_fp = (FILE*)NULL;
static FILE		*write_fp = (FILE*)NULL;
#endif	/* !MSDOS */
static unsigned int	port_number = 0;
#endif	/* POP3 */

#ifdef	POP3
static int	pop3_cmd();	/* POP3 ޥ/ơ	*/
static int	pop3_auth();	/* POP3 ǧ			*/
#endif	/* POP3 */

/*
 * POP3 
 */

POP3_ERR_CODE	pop3_select_server(server_name)
     char	*server_name;
{
#ifdef	POP3
  struct hostent	*server_entry;
#endif	/* POP3 */
#ifdef	MSPL
  static int		first = 1;
  char			spool_dir[PATH_BUFF];
  struct stat		stat_buff;
#endif	/* MSPL */
  char			*ptr;
  POP3_ERR_CODE		status;

  switch (pop3_connect_mode) {
  case 0:					/* MSPLPOP3 ³	*/
#ifndef	MSPL
    pop3_connect_mode = 1;
#endif	/* MSPL */
    break;
  case 1:					/* POP3MSPL ³	*/
#ifndef	POP3
    pop3_connect_mode = 0;
#endif	/* POP3 */
    break;
  default:
    break;
  }
  status = POP3_ERR_COMM;
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
#ifdef	MSPL
    if (first) {
      first = 0;
      strcpy(spool_dir, mail_spool);
      if (ptr = strrchr(spool_dir, SLASH_CHAR)) {
	*ptr = '\0';
      }
      if (stat(spool_dir, &stat_buff)) {
	print_fatal("Can't stat mail spool directory.");
	break;
      }
#ifdef	POP3
      if (gethostname(pop3_server, sizeof(pop3_server))) {
	print_fatal("Can't get hostname.");
	break;
      }
#else	/* !POP3 */
      strcpy(pop3_server, "LOCAL");
#endif	/* !POP3 */
    }
    status = POP3_OK;
#else	/* !MSPL */
    print_fatal("MSPL mode unsupported.");
    status = POP3_ERR_RSV;
#endif	/* !MSPL */
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
    if (server_name != (char*)NULL) {
      strcpy(pop3_server, server_name);
      ptr = strchr(server_name, ':');
      if (ptr != (char*)NULL) {
	*ptr++ = '\0';
	if (atoi(ptr) > 0) {
	  port_number = atoi(ptr) & 0xFFFF;
	}
      }
    }
    if ((server_name == (char*)NULL) || (!server_name[0])) {
      if (get_default_server(pop3_server_file, pop3_server, "POP3SERVER",
			     &port_number)) {
	if (gethostname(pop3_server, sizeof(pop3_server))) {
	  print_fatal("Can't get hostname.");
	  break;
	}
      }
    }
    if (!(server_entry = gethostbyname(pop3_server))) {
      print_warning("Can't get POP3 server host entry.");
    } else {
#ifndef	DONT_USE_REALNAME
      strcpy(pop3_server, server_entry->h_name);
#endif	/* !DONT_USE_REALNAME */
    }
    status = POP3_OK;
#else	/* !POP3 */
    print_fatal("POP3 mode unsupported.");
    status = POP3_ERR_RSV;
#endif	/* !POP3 */
    break;
  default:
    break;
  }
  if (status != POP3_OK) {
    pop3_connect_mode = 2;
  }
  return(status);
}

/*
 * POP3 ץ
 */

POP3_ERR_CODE	pop3_open()
{
  char		buff[SMALL_BUFF];
#ifdef	POP3
  int		sock_read, sock_write;
#endif	/* POP3 */
  POP3_ERR_CODE	status;

#ifdef	MSPL
  if (spool_fp != (FILE*)NULL) {
    print_fatal("MSPL server already open.");
    return(POP3_ERR_PROG);
  }
#endif	/* MSPL */
#ifdef	POP3
  read_num = -1;
#ifdef	MSDOS
  if ((write_fd != - 1) || (read_fd != - 1)) {
#else	/* !MSDOS */
  if (write_fp || read_fp) {
#endif	/* !MSDOS */
    print_fatal("POP3 server already open.");
    return(POP3_ERR_PROG);
  }
#endif	/* POP3 */
  status = POP3_ERR_COMM;
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
#ifdef	MSPL
#ifdef	POP3_DEBUG
    print_warning("Connecting to MSPL server %s.", pop3_server);
#endif	/* POP3_DEBUG */
    status = POP3_OK;
#else	/* !MSPL */
    print_fatal("MSPL mode unsupported.");
    status = POP3_ERR_RSV;
#endif	/* !MSPL */
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3_DEBUG
    print_warning("Connecting to POP3 server %s.", pop3_server);
#endif	/* POP3_DEBUG */
#ifdef	POP3
    if (pop3_rpop_mode) {
      if ((sock_read = get_tcp_socket(pop3_server, "RPOP", "rpop",
				      port_number, -1)) < 0) {
	print_fatal("Can't connect RPOP server %s.", pop3_server);
	break;
      }
    } else {
      if ((sock_read = get_tcp_socket(pop3_server, "POP3", "pop3",
				      port_number, POP3_PORT)) < 0) {
	print_fatal("Can't connect POP3 server %s.", pop3_server);
	break;
      }
    }
#ifdef	MSDOS
    read_fd = sock_read;
    sock_write = sock_read;
    write_fd = sock_write;
#else	/* !MSDOS */
    if (!(read_fp = fdopen(sock_read, "r"))) {
      print_fatal("Can't connect POP3 server %s.", pop3_server);
      break;
    }
    sock_write = dup(sock_read);
    if (!(write_fp = fdopen(sock_write, "w"))) {
      print_fatal("Can't connect POP3 server %s.", pop3_server);
      fclose(read_fp);
      read_fp = (FILE*)NULL;
      break;
    }
#endif	/* !MSDOS */
    
    /*
     * POP3 Ф³å
     */
    
    if (pop3_receive(buff, sizeof(buff))) {
      break;
    }
    if (strncmp(buff, POP3_OKAY_RES, sizeof(POP3_OKAY_RES) -1)) {
      print_fatal("POP3 error at connect sequence.");
      break;
    } else {
      status = POP3_OK;
    }
#else	/* !POP3 */
    print_fatal("POP3 mode unsupported.");
    status = POP3_ERR_RSV;
#endif	/* !POP3 */
    break;
  case 2:
    status = POP3_ERR_RSV;
    /* break  */
  default:
    break;
  }
  if (status != POP3_OK) {
    pop3_close();
    pop3_connect_mode = 2;
  }
  return(status);
}

/*
 * POP3 
 */

POP3_ERR_CODE	pop3_close()
{
  POP3_ERR_CODE	status;

  status = POP3_ERR_COMM;
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
#ifdef	MSPL
    if (spool_fp) {
#ifdef	USE_FLOCK
      flock(fileno(fp), LOCK_UN);
#endif	/* USE_FLOCK */
      fclose(spool_fp);
      spool_fp = (FILE*)NULL;
    }
    status = POP3_OK;
#endif	/* MSPL */
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
#ifdef	MSDOS
    if ((write_fd == -1) || (read_fd == -1)) {
      break;
    }
#else	/* !MSDOS */
    if ((!write_fp) || (!read_fp)) {
      break;
    }
#endif	/* !MSDOS */
    pop3_cmd(POP3_QUIT_CMD);
#ifdef	MSDOS
    closesocket(write_fd);
    read_fd = write_fd = -1;
#else	/* !MSDOS */
    if (write_fp) {
      fclose(write_fp);
      write_fp = (FILE*)NULL;
    }
    if (read_fp) {
      fclose(read_fp);
      read_fp = (FILE*)NULL;
    }
#endif	/* !MSDOS */
    status = POP3_OK;
#endif	/* POP3 */
    break;
  default:
    break;
  }
  return(status);
}

/*
 * POP3 
 */

POP3_ERR_CODE	pop3_send(string)
     char	*string;
{
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
    print_fatal("MSPL write does not need.");
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
#ifdef	MSDOS
    if (tcp_send("POP3", &read_fd, &write_fd, string)) {
      return(POP3_ERR_COMM);
    } else {
      return(POP3_OK);
    }
#else	/* !MSDOS */
    if (tcp_send("POP3", &read_fp, &write_fp, string)) {
      return(POP3_ERR_COMM);
    } else {
      return(POP3_OK);
    }
#endif	/* !MSDOS */
#endif	/* POP3 */
    break;
  default:
    break;
  }
  return(POP3_ERR_PROG);
}

/*
 * POP3 
 */

POP3_ERR_CODE	pop3_receive(ptr, size)
     char	*ptr;
     int	size;
{
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
    print_fatal("MSPL read does not need.");
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
#ifdef	MSDOS
    if (tcp_receive("POP3", &read_fd, &write_fd, ptr, size)) {
      return(POP3_ERR_COMM);
    } else {
      return(POP3_OK);
    }
#else	/* !MSDOS */
    if (tcp_receive("POP3", &read_fp, &write_fp, ptr, size)) {
      return(POP3_ERR_COMM);
    } else {
      return(POP3_OK);
    }
#endif	/* !MSDOS */
#endif	/* POP3 */
    break;
  default:
    break;
  }
  return(POP3_ERR_PROG);
}

/*
 * POP3 ס꡼
 */

POP3_ERR_CODE	pop3_read(ptr, size, stat_ptr)
     char		*ptr;
     int		size;
     POP3_RD_STAT	*stat_ptr;
{
  static int	field;
#ifdef	MSPL
  static long	length1, length2;
#endif	/* MSPL */
#ifdef	POP3
  char		buff[BUFF_SIZE];
#endif	/* POP3 */
  POP3_ERR_CODE	status;

  status = POP3_ERR_COMM;
  *ptr = '\0';
  *stat_ptr = POP3_RD_OK;
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
#ifdef	MSPL
    if (spool_fp == (FILE*)NULL) {
      spool_fp = fopen(mail_spool, "r");
      if (spool_fp == (FILE*)NULL) {
	break;
      }
#ifdef	USE_FLOCK
      flock(fileno(fp), LOCK_EX);
#endif	/* USE_FLOCK */
      field = 2;
      length1 = length2 = 0;
    }
    status = POP3_OK;
    if (!fgets(ptr, size, spool_fp)) {
      *ptr = '\0';
      *stat_ptr = POP3_RD_EOF;
      break;
    }
    length2 += strlen(ptr);
    if (field == 2) {
      if (*ptr == '\n') {
	if (!fgets(ptr, size, spool_fp)) {
	  *ptr = '\0';
	  *stat_ptr = POP3_RD_EOF;
	  break;
	}
      }
      if (strncmp(ptr, MSPL_SEPARATER, sizeof(MSPL_SEPARATER) - 1)) {
	break;				/* եޥå	*/
      }
      if (!fgets(ptr, size, spool_fp)) {
	*ptr = '\0';
	*stat_ptr = POP3_RD_EOF;
	break;
      }
      field = 1;
    }
    if (field) {
      if (*ptr == '\n') {
	field = 0;
	*stat_ptr = POP3_RD_SEP;
	break;
      }
      if (!strncasecmp(ptr, LENGTH_FIELD, sizeof(LENGTH_FIELD) - 1)) {
	length1 = atoi(ptr + sizeof(LENGTH_FIELD) - 1);
      }
    } else {
      length2 += strlen(ptr);
      if (!strncmp(ptr, MSPL_SEPARATER, sizeof(MSPL_SEPARATER) - 1)) {
	if (length1 ? length2 >= length1 : 1) {
	  field = 1;
	  length1 = length2 = 0;
	  *stat_ptr = POP3_RD_END;
	  break;
	}
      }
    }
#else	/* !MSPL */
    status = POP3_ERR_RSV;
#endif	/* !MSPL */
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
    if (read_num < 0) {
      if (pop3_auth()) {
	break;
      }
      if (pop3_send(POP3_STAT_CMD)) {
	break;
      }
      if (pop3_receive(buff, sizeof(buff))) {
	break;
      }
      if (strncmp(buff, POP3_OKAY_RES, sizeof(POP3_OKAY_RES) -1)) {
	break;
      }
      spool_num = atoi(&buff[4]);
      read_num = 0;
      field = 2;
    }
    if (field == 2) {
      if (read_num < spool_num) {
	sprintf(buff, "%s %d", POP3_RETR_CMD, read_num + 1);
	if (pop3_cmd(buff)) {
	  break;
	}
      } else {
	*stat_ptr = POP3_RD_EOF;
	return(POP3_OK);
      }
      field = 1;
    }
    if (pop3_receive(buff, sizeof(buff))) {
      field = 2;
      break;
    }
    status = POP3_OK;
    strcat(buff, "\n");
    if (field) {
      strncpy(ptr, buff, size);
      if (buff[0] == '\n') {
	field = 0;
	*stat_ptr = POP3_RD_SEP;
	break;
      }
    } else if (buff[0] == POP3_END_MARK) {
      strncpy(ptr, &buff[1], size);
      if (*ptr == '\n') {
	field = 2;
	read_num++;
	if (read_num < spool_num) {
	  *stat_ptr = POP3_RD_END;
	} else {
	  *stat_ptr = POP3_RD_EOF;
	}
	break;
      }
    } else {
      strncpy(ptr, buff, size);
    }
    *(ptr + size - 1) = '\0';
    *stat_ptr = POP3_RD_OK;
#else	/* !POP3 */
    status = POP3_ERR_RSV;
#endif	/* !POP3 */
    break;
  default:
    break;
  }
  return(status);
}

/*
 * POP3 סå
 */

POP3_ERR_CODE	pop3_stat()
{
#ifdef	MSPL
  struct stat	stat_buff;
#endif	/* MSPL */
#ifdef	POP3
  char		buff[BUFF_SIZE];
#endif	/* POP3 */
  POP3_ERR_CODE	status;

  status = pop3_open(pop3_server);
  if (status == POP3_OK) {
    switch (pop3_connect_mode) {
    case 0:						/* MSPL ³	*/
#ifdef	MSPL
      if ((!stat(mail_spool, &stat_buff)) && (stat_buff.st_size > 0)) {
	status = POP3_OK;
      } else {
	status = POP3_ERR_NONE;
      }
#endif	/* MSPL */
      break;
    case 1:						/* POP3 ³	*/
#ifdef	POP3
      status = pop3_auth();
      if (status != POP3_OK) {
	break;
      }
      status = POP3_ERR_COMM;
      if (pop3_send(POP3_STAT_CMD)) {
	break;
      }
      if (pop3_receive(buff, sizeof(buff))) {
	break;
      }
      if (strncmp(buff, POP3_OKAY_RES, sizeof(POP3_OKAY_RES) -1)) {
	break;
      }
      if (atoi(&buff[4]) > 0) {
	status = POP3_OK;
      } else {
	status = POP3_ERR_NONE;
      }
#endif	/* POP3 */
      break;
    default:
      break;
    }
    pop3_close();
  }
  return(status);
}

/*
 * POP3 ס
 */

POP3_ERR_CODE	pop3_delete()
{
#ifdef	MSPL
  FILE		*fp;
#endif	/* MSPL */
#ifdef	POP3
  char		buff[BUFF_SIZE];
  register int	i;
#endif	/* POP3 */

  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
#ifdef	MSPL
    if ((fp = fopen(mail_spool, "w")) != (FILE*)NULL) {
      if (!fclose(fp)) {
	return(POP3_OK);
      }
    }
    print_fatal("Can't truncate spool file.");
#endif	/* MSPL */
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
    for (i = 0; i < read_num; i++) {
      sprintf(buff, "%s %d", POP3_DELE_CMD, i + 1);
      if (pop3_cmd(buff)) {
	i = 0;
	break;
      }
    }
    if (i) {
      return(POP3_OK);
    }
#endif	/* POP3 */
    break;
  default:
    break;
  }
  return(POP3_ERR_COMM);
}

/*
 * POP3 ³ǧ
 */

POP3_ERR_CODE	pop3_noop()
{
  switch (pop3_connect_mode) {
  case 0:						/* MSPL ³	*/
    break;
  case 1:						/* POP3 ³	*/
#ifdef	POP3
    return(pop3_cmd(POP3_NOOP_CMD));
#endif	/* POP3 */
    break;
  default:
    break;
  }
  return(POP3_OK);
}

#ifdef	POP3
/*
 * POP3 ǧ
 */

static int	pop3_auth()
{
  static char	user[SMALL_BUFF];
  static char	pass[SMALL_BUFF];
  static int	first = 1;
  char		buff[BUFF_SIZE];
  POP3_ERR_CODE	status;

  if (first) {
    if (pop3_rpop_mode) {
      get_user_pass(pop3_server, user, (char*)NULL);
      strcpy(pass, user);
    } else {
      get_user_pass(pop3_server, user, pass);
    }
  }
  sprintf(buff, "%s %s", POP3_USER_CMD, user);
  status = pop3_cmd(buff);
  if (status != POP3_OK) {
    return(status);
  }
  sprintf(buff, "%s %s", pop3_rpop_mode ? POP3_RPOP_CMD : POP3_PASS_CMD, pass);
  status = pop3_cmd(buff);
  if (status != POP3_OK) {
    return(status);
  }
  first = 0;
  return(POP3_OK);			/* Authentication accepted */
}

/*
 * POP3 ޥ/ơ
 */

static int	pop3_cmd(cmd)
     char	*cmd;
{
  char		*ptr1;
  char		*ptr2;
  char		buff[BUFF_SIZE];
  POP3_ERR_CODE	status;

  status = pop3_send(cmd);
  if (status != POP3_OK) {
    return(status);
  }
  status = pop3_receive(buff, sizeof(buff));
  if (status != POP3_OK) {
    return(status);
  }
  if (!strncmp(buff, POP3_OKAY_RES, sizeof(POP3_OKAY_RES) -1)) {
    return(POP3_OK);
  }
  ptr1 = buff;
  ptr2 = cmd;
  while (*ptr2) {
    if (*ptr2 <= ' ') {
      break;
    }
    *ptr1++ = *ptr2++;
  }
  *ptr1 = '\0';
  print_fatal("POP3 error at %s command.", buff);
  return(POP3_ERR_PROT);
}
#endif	/* POP3 */
